#include "asm86.h"
#include "old86.h"
#include "ti86asm.inc"

_load_ram_ahl       equ     $462F	;Converts ahl to ASIC, loads RAM page.

_dispahl            equ     $4A33	;Displays ahl in decimal.

_runoff				equ     $4AB1	;Disable run indicator.

_runon              equ     $4AAD	;Enable run indicator.

_off                equ     $4101	;Turn off calc.

_getcode            equ     $4068	;Get scancode, but 1000's of clocks faster than GET_KEY.

_exec_asm           equ     $5730	;Execute z80 assembly program in OP1.

_op5toop1           equ     $4247   ;copy _op5 to _op1
_op1toop5           equ     $426B   ;copy _op1 to _op5
anumeditflgs        equ     $1F     ;used for Clem's various programs
ex_asm_module       equ     $02     ;as well as this

;Some stuff in _asm_exec_ram

#define RelocArea           $E700
#define Cur_Folder          $E900
#define Prev_Folder         $E900+1
#define Return_Where        $E900+2
#define Folder_Name         $E900+3
#define TotalDTs            $E900+13
#define Pointer2dtVAT       $E900+14
#define dtVAT               $E900+16
#define	TotalVars           $EB00
#define	PointerPos          $EB00+2
#define	Pointer2VAT         $EB00+4
#define	Pointer2AVAT        $EB00+6
#define	AVAT                $EB00+8

.org _asm_exec_ram

DTdetecter:
    ei
    res  ex_asm_module,(iy+anumeditflgs)
    ld   a,(Return_Where)					;in order for the folderDT to work
    cp   $31								;we have to get info from it.
    jr   nz,Detecter						;if ($E902) != $31 then goto Detecter
    xor  a
    ld   (Return_Where),a					;clear the $31
    ld   a,(Cur_Folder)
    ld   (CurFolder),a
    ld   a,(Prev_Folder)					;and save someother info
    ld   (PrevFolder),a
    call CopyPrevName						;copy current folder name to previous
    ld   hl,Folder_Name
    ld   de,CurFolderStr					;and copy the new one into current
    ld   bc,9
    ldir
    jp   ScreenSetup						;dont have to re-detect DT (we hope)

Detecter:
    xor  a
    ld   (TotalDTs),a
    ld   hl,dtVAT
    ld   (Pointer2dtVAT),hl					;initialize some vars
    ld   hl,$BFFF
    ld   a,$47								;set the proper ram page (the one with the vat)
    out  (6),a
dtSearchLoop:
    ld   de,(VAT_END)
    inc  de
    or   a
    sbc  hl,de
    jp   c,EndOfDTs
    add  hl,de
    ld   (Pointer2VAT),hl					;this is the start of the vat entry
    ld   a,(hl)
    cp   $0C								;needs to be a string
    jp   nz,dtSkipVarName					;no? go to here

dtMoveName2OP1:
    ld   de,-5
    add  hl,de
    ld   b,(hl)								;save length byte for djnz
    inc  b
    ld   ix,_OP1							;this is where we are gonna put the var name
dtName2OP1:
    inc  ix
    ld   a,(hl)
    ld   (ix),a
    dec  hl									;simple routine to move b bytes from hl to ix (backward)
    djnz dtName2OP1

dtCheckLoop:
    rst  10h
    ld   a,b
    ex   de,hl	
    call _load_ram_ahl
    inc  hl
    inc  hl
    ld   a,(hl)				;get the first byte
    cp   0					;make sure that it was a nop
    jr   nz,dtSkipVarName	;if not, start on the next var
    inc  hl					;have to check the next byte as well
    ld   a,(hl)				;so get it
    cp   $4D				;make sure its 'M'
    jr   nz,dtSkipVarName	;if not, start the next var
    call SetPorts4Move
    ld	 de,9				;yay, it was :)
    add  hl,de
    ld   b,(hl)				;this is how many DTs there are in the file
    ld   a,(TotalDTs)		
    add  a,b				;add em to our DT var
    ld   (TotalDTs),a
    push hl					;copy hl to ix
    pop  ix
    inc	 ix					;point to the first data type
MovedtTables:
    push bc					;save b (the counter)
    ld   a,(ix+2)			;ix+2 is the length of the table
    add  a,a				;the size byte is only half the actuall size (becuase the mask needs to be included
    add  a,3				;and there are 3 bytes before the size
    ld	 b,a				;so b= 3 + (length*2)
    ld   de,(Pointer2dtVAT)
MoveTable:					;move a table of data from this DT var
    ld   a,(ix)
    ld   (de),a
    inc  ix
    inc  de
    djnz MoveTable
    ld   hl,_OP1+1
    ld   b,9
MoveVATentry:
    ld   a,(hl)
    ld   (de),a
    inc  hl
    inc  de
    djnz MoveVATentry
    ld   (Pointer2dtVAT),de
    pop  bc
    djnz MovedtTables		;move another one

dtSkipVarName:
    ld   a,$0d
    out  (5),a
    ld   a,$47
    out  (6),a
    ld   hl,(Pointer2VAT)
    ld   de,-5
    add  hl,de
    ld   b,(hl)
    inc  b
dtSkipName:
    dec  hl
    djnz dtSkipName
    jp   dtSearchLoop

EndOfDTs:
    ld   a,(TotalDTs)
    cp   0							;how many did we find?
    ret  z							;if none, exit program

ScreenSetup:
    call _clrScrn
    call _runoff
    call _flushallmenus
    call DoLines
    ld   a,0						;now we shall check and see if folderDT
    ld   (folderDThere),a			;enhancements can be used
    ld   hl,folderDTname
    rst  20h
    rst  10h						;...variable lookup
    jr   c,InitVarStuff
    ld   a,1
    ld   (folderDThere),a			;tell other routines that it is here

InitVarStuff:
    call DoTopBar					;routine to draw the current folder and such
    xor  a
    ld   (TotalVars),a
    ld   hl,AVAT					;setup the avat pointer
    ld   (Pointer2AVAT),hl
    ld   a,(folderDThere)
    cp   0
    jr   z,NoStrings
FindStringsFirst:
    ld   a,$C2
    ld   (jumper2),a				;some self modifying code to use 1 routine for
    call FindVars					;2 very different things
NoStrings:
    ld   a,$CA
    ld   (jumper2),a
    call FindVars
    ld   a,(TotalVars)
    cp   0
    jp   z,DispNoProgs
    ld   a,(CurVar)
    ld   b,a
    ld   a,(TotalVars)				;some stuff to put the cursor back where it was
    cp   b							;previously
    jr   c,ResetPosr
    push bc
    ld   a,(VarPage)
    ld   h,a
    ld   l,24
    call MUL_HL
    ld   a,l
    sub  23
    ld   (CurVar),a
    ld   a,(Posr)
    push af
    call DispProgs
    pop  af
    ld   (Posr),a
    ld   b,a
    pop  af
    ld   (CurVar),a
    jr   FinishInit

ResetPosr:
    ld   a,1
    ld   (CurVar),a
    ld   (VarPage),a
    call DispProgs
    ld   a,1
    ld   (CurVar),a
    ld   (Posr),a

FinishInit:
    set  3,(iy+5)
    call DisplayHandler
    call Get_Size
    res  3,(iy+5)

VarsGetLoop:						;the main getkey loop
    halt
    call _getcode
    cp   K_NOKEY
    jr   z,VarsGetLoop
    cp	 K_MORE
    jp   z,BackAFolder
    cp   K_PLUS
    call z,ContrastUp
    cp   K_MINUS
    call z,ContrastDn
    cp   K_LEFT
    jp   z,ProgLeft
    cp   K_RIGHT
    jp   z,ProgRight
    cp   K_EXIT
    jp   z,Exit
    cp   K_GRAPH
    jp   z,Back2Folder0
    cp   K_TAN
    jp   z,PasteVar
    cp   K_CLEAR
    call z,ShutCalcOff
    cp   K_RAISE
    jp   z,ShutDownWP
    cp   K_COMMA
    jp   z,GetNewPass
    cp   K_LOG
    jp   z,FolderUp
    cp   K_LN
    jp   z,FolderDown
    cp   K_XVAR
    jp   z,MakeNewFolder
    cp   K_CUSTOM
    jp   z,RenameFolder
    ld   hl,FinishSaveCurFolder
    cp   K_F1
    jp   z,TwasF1
    cp   K_F2
    jp   z,TwasF2
    cp   K_F3
    jp   z,TwasF3
    cp   K_F4
    jp   z,TwasF4
    cp   K_F5
    jp   z,TwasF5
    ld   b,a
    ld   a,(TotalVars)
    cp   0
    jr   z,VarsGetLoop						;dont check keys after here
    ld   a,b								;if no vars have been found
    cp   K_UP
    jp   z,ProgUp
    cp   K_DOWN
    jp   z,ProgDown
    cp   K_SECOND
    jp   z,ExecProg
    cp   K_ENTER
    jp   z,ExecProg
    cp   K_STO
    jp   z,MoveProg
    cp   K_COS
    jp   z,CopyCurVar
    cp   K_ALPHA
    jp   z,RenameVar
    jp   VarsGetLoop

CopyCurVar:
    call UpdateCurProg
    ld   de,Copy_Queue
    ld   bc,10
    ldir
    call ClearDescriptPlace
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,FileCutStr
    call _vputs
    jp   VarsGetLoop

PasteVar:
    ld   a,(Copy_Queue)
    cp   0
    jp   z,VarsGetLoop
    ld   hl,Copy_Queue
    rst  20h
    rst  10h
    jp   c,ScreenSetup
    ld   de,-4
    add  hl,de
    ld   a,(CurFolder)
    ld   (hl),a
    xor  a
    ld   (Copy_Queue),a
    jp   InitVarStuff
    
ProgLeft:
    ld   a,(Posr)
    sub  9
    jp   c,VarsGetLoop
    call DisplayHandler
    ld   a,(Posr)
    sub  8
    ld   (Posr),a
    ld   a,(CurVar)
    sub  8
    ld   (CurVar),a
    jp   DisplayProg

ProgRight:
    ld   a,(Posr)

    sub  17
    jp   nc,VarsGetLoop
    ld   a,(CurVar)
    add  a,8
    ld   b,a
    ld   a,(TotalVars)
    sub  b
    jp   c,VarsGetLoop
    call DisplayHandler

    ld   a,(Posr)
    add  a,8
    ld   (Posr),a
    ld   a,(CurVar)
    add  a,8
    ld   (CurVar),a
    jp   DisplayProg

ProgUp:
    ld   a,(CurVar)
    cp   1
    jp   z,VarsGetLoop
    call DisplayHandler

    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    ld   a,(Posr)

    cp   1

    jr   nz,SkipPageUp
    ld   a,(VarPage)
    dec  a
    ld   (VarPage),a
    ld   a,(CurVar)
    sub  23
    ld   (CurVar),a
    call DispProgs
    ld   a,25
SkipPageUp:
    dec  a
    ld   (Posr),a

    jp   DisplayProg



ProgDown:
    ld   a,(CurVar)
    ld   hl,TotalVars
    cp   (hl)
    jp   z,VarsGetLoop
    call DisplayHandler
    ld   a,(CurVar)
    inc  a
    ld   (CurVar),a
    ld   a,(Posr)
    cp   24
    jr   nz,SkipPageDown
    ld   a,(VarPage)
    inc  a
    ld   (VarPage),a
    ld   a,(CurVar)
    push af
    call DispProgs
    pop  af
    ld   (CurVar),a
    ld   a,0
SkipPageDown:
    inc  a
    ld   (Posr),a
DisplayProg:
    set  3,(iy+5)
    call DisplayHandler

    res  1,(iy+5)
    call Get_Size
    jp   VarsGetLoop


;------------------folder navigation routines-------------------

Back2Folder0:
    ld   a,(CurFolder)
    ld   (PrevFolder),a
    xor  a
    ld   (CurFolder),a
    call CheckCopy1to5
    jp   ScreenSetup

BackAFolder:
    ld   a,(CurFolder)
    push af
    ld   a,(PrevFolder)
    ld   (CurFolder),a
    pop  af
    ld   (PrevFolder),a
    call ExchangeNames
    jp   ScreenSetup

FinishSaveCurFolder:
    push af
    ld   a,(CurFolder)
    ld   (PrevFolder),a
    pop  af
    ld   (CurFolder),a
    call CopyPrevName
    call CheckCopy1to5
    jp   ScreenSetup

FolderUp:
    call CopyPrevName
    ld   a,(CurFolder)
    ld   (PrevFolder),a
    inc  a
    ld  (CurFolder),a
    call NoFolderName
    call CheckCopy1to5
    jp   ScreenSetup

FolderDown:
    call CopyPrevName
    ld   a,(CurFolder)
    ld   (PrevFolder),a
    dec  a
    ld  (CurFolder),a
    call NoFolderName
    call CheckCopy1to5
    jp  ScreenSetup

;--------------------No programs found :o( ------------------    
DispNoProgs:
    ld   hl,$391D
    ld   (_penCol),hl
    ld   hl,ProgramName
    call _vputs
    ld   hl,$FF90
    call InvertFullBar
    ld   hl,$182A
    ld   (_penCol),hl
    ld   hl,NoProgs_Str
    call _vputs
    call GetFreeMem
    jp   VarsGetLoop

;---------------------Nice routine that finds the proper dt and execs it-------

ExecProg:
    call SaveVars
    call GetdtVar
    push hl					;save it while we are pointing to the start of the program
    ld   de,6
    add  hl,de
    ld   e,(hl)
    inc  hl					;exec code is de bytes down the road
    ld   d,(hl)
    inc  hl
    ld   c,(hl)
    inc  hl					;and bc is how many bytes the routine is
    ld   b,(hl)
    pop  hl					;get hl back pointing to the comment dw
    add  hl,de					;point hl to the comment routine
    ld   de,RelocArea			;this is where it will run from
    ldir					;copy the routine to RelocArea
    call SetPortsNorm
    call UpdateCurProg
    rst	 20h
    ld	 a,(_OP1)
    jp	 RelocArea				;call the routine. 

;--------------------sombody pressed STO> --------------------

MoveProg:
    call ClearDescriptPlace
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,MoveWhere
    call _vputs
MoveGetLoop:
    halt
    call _getcode
    cp   K_NOKEY
    jr   z,MoveGetLoop
    cp   K_EXIT
    jp   z,InitVarStuff
    ld   hl,MoveIt
    cp   K_F1
    jr   z,TwasF1
    cp   K_F2
    jr   z,TwasF2
    cp   K_F3
    jr   z,TwasF3
    cp   K_F4
    jr   z,TwasF4
    cp   K_F5
    jr   z,TwasF5
    cp   K_DEL
    jr   z,DeleteProg
    jr   MoveGetLoop

TwasF1:
    ld   a,0
    jp   (hl)
TwasF2:
    ld   a,1
    jp   (hl)
TwasF3:
    ld   a,2
    jp   (hl)
TwasF4:
    ld   a,3
    jp   (hl)
TwasF5:
    ld   a,4
    jp   (hl)

MoveIt:
    push af
    call UpdateCurProg
    rst  20h
    rst  10h
    ld   de,-4
    add  hl,de
    pop  af
    ld   (hl),a
    jr   FixFromMove
	
DeleteProg:
    call UpdateCurProg
    rst  20h
    ld   a,(_OP1)
    cp   'F'
    call z,DecDaFolda
    rst  10h
    call nc,_delvar
FixFromMove:
    call ClearProgPlace
    call ClearDescriptPlace
    ld   a,(Posr)
    cp   1
    jr   z,TisAtTop
    ld   c,a
    ld   a,(CurVar)
    ld   b,a
    ld   a,(TotalVars)
    dec  a					;just deleted a var, so we must dec it
    cp   b
    jp   nc,InitVarStuff
    ld   a,c
    dec  a
    ld   (Posr),a
    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    jp   ScreenSetup

TisAtTop:
    ld   a,(VarPage)
    cp   1
    jp   z,ScreenSetup
    ld   a,24
    ld   (Posr),a
    ld   a,(CurVar)
    dec  a
    ld   (CurVar),a
    ld   a,(VarPage)
    dec  a
    ld   (VarPage),a    
    jp   DTdetecter

;-----------------routine to make a new pseudo folder--------------------

MakeNewFolder:
    ld   a,(folderDThere)
    cp   0
    jp   z,VarsGetLoop
    ld   a,(TotalFolders)
    cp   255
    jp   z,InitVarStuff
    call CleanUpBuffer
    call ClearDescriptPlace
    ld   a,0
    ld   (ReturnByte),a
    ld   hl,TextBuffer+8
    ld   (TextEndPtr),hl
    ld   a,'/'
    ld   (TextBuffer),a
    ld   hl,TextBuffer+1
    ld   (TextPtr),hl
    call RenameGetLoop
	jp   z,ScreenSetup
    ld   hl,TextBuffer-2
    rst  20h
    ld   hl,(TextPtr)
    ld   de,TextBuffer
    sbc  hl,de
    ld   a,l
    inc  a
    ld   (_OP1+1),a
    rst  10h
    jp   nc,ErrorBadName
    call _op1toop5
    ld   hl,3
    call _createstrng
    call _op5toop1
    rst  10h
    push de
    ld   de,-4
    add  hl,de
    ld   a,(CurFolder)
    ld   (hl),a
    pop  hl
    ld   a,b
    call _load_ram_ahl
    inc  hl
    inc  hl
    ld   (hl),0
    inc  hl
    ld   (hl),'F'
    inc  hl
    call IncDaFolda
    ld   (hl),a
    jp   ScreenSetup

DecDaFolda:
    ld   a,(TotalFolders)
    dec  a
    ld   (TotalFolders),a
    ret

IncDaFolda:
    ld   a,(TotalFolders)
    inc  a
    ld   (TotalFolders),a
    ret

;--------------------get the comment and size of a var-------------------

Get_Size:
    call GetdtVar
    push hl
    inc  hl
    inc  hl
    ld   e,(hl)
    inc  hl						;comment code is de bytes down the road
    ld   d,(hl)
    inc  hl
    ld   c,(hl)
    inc  hl						;and bc is how many bytes the routine is
    ld   b,(hl)
    pop  hl						;get hl back pointing to the comment dw
    add  hl,de					;point hl to the comment routine
    ld   de,RelocArea			;this is where it will run from
    ldir						;copy the routine to RelocArea
    call SetPortsNorm
    call UpdateCurProg
    rst  20h
    ld   a,(_OP1)				;we want to save the 1 letter description for the comment routines
    ld   (_OP2),a
    rst  10h						;now we're gonna setup the correct pages and such for the program
    ld   a,b
    ex   de,hl
    call _load_ram_ahl	
    call SetPorts4Move
    ld   a,(hl)					;get the size while its handy
    ld   (_OP2+2),a
    inc	 hl
    ld   a,(hl)
    ld   (_OP2+1),a				;put it into OP2+1
    inc  hl						;hl points to the first byte of the program
    ld   a,(_OP2)				;a has the 1 byte description
    call RelocArea				;call the routine. nc means that a descript was found
    jr   nc,DisplayInfo			

RegularMove:						;if there was a carry, just copy the name as the description
    ld   hl,_OP1+2
    ld   de,_OP2+3
    ld   a,(_OP1+1)
    ld   c,a
    ld   b,0
    ldir 
    xor  a
    ld   (de),a

DisplayInfo:
    call SetPortsNorm
    set  3,(iy+5)				;size will be white on black
    ld   de,$005C

    ld   (_penCol),de
    ld   hl,SizeStr
    call _vputs

    ld   a,(_OP2+2)
    ld   l,a
    ld   a,(_OP2+1)
    ld   h,a
    xor  a

    ld   de,-1

    ld   (_curRow),de

    call _dispahl

    dec  hl

    call _vputs
    ld   b,13
BustOutSomeSpaces:
    ld   a,' ' 
    call _vputmap
    djnz BustOutSomeSpaces
    res  3,(iy+5)
    call ClearDescriptPlace
    ld   de,$3901

    ld   (_penCol),de
    ld   hl,_OP2+3
    call _vputs
    ld   de,$3969

    ld   (_penCol),de
    ld   hl,TypeStr
    call _vputs
    ld   a,(_OP2)
    call _vputmap
    ret

;----------this is the main routine that decides where programs are disp'd--------

DisplayHandler:
    call UpdateCurProg
    rst  20h
    set  1,(iy+5)
    ld   a,(Posr)

    ld   b,08
    cp   9
    jr   c,NormalDisp
    cp   17
    jr   c,SecondCol
ThirdCol:
    sub  16
    ld   b,85
    jr   NormalDisp
SecondCol:
    sub  8
    ld   b,46
NormalDisp:
    push bc
    ld   h,a

    ld   l,6

    call MUL_HL

    inc  hl
    ld   (_penRow),hl

    pop  bc
    ld   a,b

    ld   (_penCol),a

    ld   hl,Spaces_Str
    call _vputs
    ld   a,(_OP1+1)
    ld   b,a
    ld   hl,_OP1+2
    call _vputsn
    ld   hl,Spaces_Str
    call _vputs
    res  1,(iy+5)
    ret

;----------most important routine in the program...finds the vars----------

FindVars:
    ld   hl,$BFFF
    ld   a,$47
    out  (6),a
SearchLoop:
    ld   de,(VAT_END)
    inc  de
    or   a
    sbc  hl,de
    ret	 c
    add  hl,de
    ld	 (Pointer2VAT),hl	;this is the start of the vat entry
    ld   a,(hl)
    cp   $0C
jumper2:					;little bit of self modifying code here :o)
    jp   nz,SkipVarName
    ld	 de,-4				;go to where the folder byte is
    add	 hl,de
    ld	 b,(hl)				;this is what folder the var goes in
    ld	 a,(CurFolder)		;this is what folder we want to find
    cp	 b					;check if they are the same
    jp	 nz,SkipVarName		;no? go to here

MoveName2OP1:
    dec  hl
    ld 	 b,(hl)				;save length byte for djnz
    inc	 b
    ld 	 ix,_OP1			;this is where we are gonna put the var name
Name2OP1:
    inc  ix
    ld   a,(hl)
    ld 	 (ix),a
    dec  hl					;simple routine to move b bytes from hl to ix (backward)
    djnz Name2OP1

CheckVarName:
    ld   a,(_OP1+2)
    cp   $10					;check if its a sqrt program
    jp   z,SkipVarName			;thats an evil var
    cp   '#'					;this on is too
    jp   z,SkipVarName
    cp   '!'					;and this one as well
    jp   z,SkipVarName
    cp   'm'					;check if its mse
    jr   nz,LoadVar
    ld   a,(_OP1+3)
    cp   's'
    jr   nz,LoadVar
    ld   a,(_OP1+4)
    cp   'e'
    jp   z,SkipVarName

LoadVar:
    rst  10h
    ld   a,b
    ex   de,hl
    call _load_ram_ahl
    call SetPorts4Move
    inc	 hl
    inc	 hl					;this is where the good stuff starts in a program
    ld   (tmpVarPtr),hl		;save this for later use
    ld   ix,dtVAT			;ix it the table
    ld   a,(TotalDTs)
    ld   c,a

CompareVar2Table:			;hl is the program, ix is the var table
    ld   a,(_OP1)			;var type is in (_OP1)
    cp   (ix)				;and hl is pointing at the var type 
    jr   nz,FixIX
MainSearchLoop:
    inc  ix
    inc  ix
    ld   a,(ix)					;get the table length
    push ix						;save when its at the table length byte
    inc  ix						;point to the table
    ld   b,a					;use b as the counter
	inc  b						;gotta do b+1 to make it iterate correctly
    ld   hl,(tmpVarPtr)
    call CompareBytesLoop
    pop  ix
    jr   nc,GoodVarFound
TryNextDT:
    dec  c
    ld   a,0
    cp   c
    jp   z,SkipVarName
    ld   a,(ix)
    add  a,a
    add  a,10
    ld   e,a
    ld   d,0
    add  ix,de
    jr   CompareVar2Table
FixIX:
    inc  ix
    inc  ix
    jr   TryNextDT

CompareBytesLoop:
    or   a						;reset carry flag
    dec  b
    ret  z						;ret if b is 0
    ld   a,(ix)
    ld   (jumper),a
    inc  ix
    ld   a,(ix)
    cp   (hl)
    inc  hl
    inc  ix
jumper:							;some sweet self modifying code
    jr   CompareBytesLoop
    scf
    ret

GoodVarFound:
    dec  ix
    ld   a,(ix)
    ld   (_OP1),a
    dec  ix
    ld   (_OP1+10),ix
    ld   hl,_OP1
    ld 	 de,(Pointer2AVAT)
    ld   bc,12				;12 bytes from _OP1 to the AVAT
    ldir
    ld   hl,(Pointer2AVAT)
    ld   de,12
    add  hl,de
    ld   (Pointer2AVAT),hl
    ld   a,(TotalVars)
    inc  a
    ld   (TotalVars),a
SkipVarName:
    ld   a,$0d
    out  (5),a
    ld   a,$47
    out  (6),a
    ld   hl,(Pointer2VAT)
    ld   de,-5
    add  hl,de
    ld   b,(hl)
    inc  b
SkipName: 
    dec  hl
    djnz SkipName
    jp   SearchLoop

;-----------------disp a maximum of 24 programs to the screen--------------

DispProgs:
    call ClearProgPlace	
    ld   a,1
    ld   (Posr),a
TheMoveLoop:
    call DisplayHandler
    ld   a,(Posr)
    inc  a
    ld   (Posr),a
    cp   25
    ret  z
    ld   a,(CurVar)
    ld   hl,TotalVars
    cp   (hl)
    ret  z
    inc  a
    ld   (CurVar),a
    jr   TheMoveLoop	

;--------find address in AVAT of the currently selected program-----------

UpdateCurProg:
    ld   a,(CurVar)
    ld   h,a
    ld   l,12
    call MUL_HL
    ld   de,AVAT-12
    add  hl,de
    ret 

GetdtVar:
    call UpdateCurProg
    ld   de,10
    add  hl,de
    ex   de,hl
    ld   a,(de)
    ld   l,a
    inc  de
    ld   a,(de)
    ld   h,a
    inc  hl
    inc  hl
    ld   a,(hl)
    add  a,a
    ld   e,a
    ld   d,0
    add  hl,de
    rst  20h
    rst  10h
    ld   a,b
    ex   de,hl
    call _load_ram_ahl	
    call SetPorts4Move
    inc  hl
    inc  hl						;past the size			
    ret
 
SetPortsNorm:
    ld   a,$0D					;put the pages back so we dont fuck stuff up
    out  (5),a
    ld   a,$41
    out  (6),a
    ret

SetPorts4Move:
    in   a,(6)					;and setup the program
    out  (5),a					;for searching.
    inc  a
    out  (6),a
    ld   de,-$4000
    add  hl,de
    ret 

DrawVLine:
    ld   a,(hl)
    or   c
    ld   (hl),a
    add  hl,de

    djnz DrawVLine

    ret

DrawHLine:
    ld   a,$FF
    ld   (hl),a

    inc  hl

    djnz DrawHLine

    ret

;-------------clear the part of the screen where progs are displayed
ClearProgPlace:
    ld   hl,$FC71
    ld   c,49

    ld   b,14

ClearVars:
    ld   a,0
    ld   (hl),a

    inc  hl

    djnz ClearVars

    ld   de,2

    add  hl,de

    dec  c

    ld   a,c

    or   a

    ld   b,14
    jr   nz,ClearVars

    call DoLines
    ret

;-------------------------clear the bottom 7 lines ---------------
ClearDescriptPlace:
    ld   a,0
    ld   hl,$FF90
    ld   (hl),a
    ld   de,$FF91
    ld   bc,112
    ldir
    ret

;----------------display the current folder and such----------------

DoTopBar:
    ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,111
    ldir
    set  1,(iy+5)
    ld   de,$0001
    ld   (_penCol),de
    ld   a,' '
    call _vputmap
    ld   hl,CurFolderStr
    call _vputs
    ld   a,' '
    call _vputmap
    res  1,(iy+5)
    ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,15
    ldir
    ret

CheckCopy1to5:
    ld   a,(CurFolder)
    cp   5
    ret  nc
    call CopyPrevName
    ld   hl,Folders
    cp   0
    jr   z,NoAdding
    ld   l,a
    ld   h,9
    call MUL_HL
    ld   de,Folders
    add  hl,de
NoAdding:
    ld   de,CurFolderStr
    ld   bc,9
    ldir
    ret
 
NoFolderName:
    call CopyPrevName
    ld   a,(CurFolder)
    ld   hl,CurFolderStr
    ld   (hl),a
    inc  hl
    ld   (hl),0
    ret

CopyPrevName:
    ld   hl,CurFolderStr
    ld   de,PrevFolderStr
    ld   bc,9
    ldir
    ret

ExchangeNames:
    ld   hl,CurFolderStr
    ld   de,PrevFolderStr
    ld   b,9
ExchangeLoop:
    ld   c,(hl)
    ld   a,(de)
    ld   (hl),a
    ld   a,c
    ld   (de),a
    inc  hl
    inc  de
    djnz ExchangeLoop
    ret

GetFreeMem:
	ld   hl,$2A12
	ld   (_penCol),hl
	ld   hl,FreeStr
	call _vputs
	call _memchk
	call DispHL
	ld   hl,BytesStr
	call _vputs
	ret

DoLines:
    ld   b,49

    ld   hl,$FC70

    ld   c,%10000000

    ld   de,16

    call DrawVLine
    ld   b,49

    ld   hl,$FC7F

    ld   c,%00000001

    ld   de,16

    call DrawVLine
    ld   b,16
    ld   hl,$FF80
    call DrawHLine
    ret

InvertFullBar:
    ld   b,$70

InvertFullBarLoop:
    ld   a,(hl)

    cpl
    ld   (hl),a

    inc  hl

    djnz InvertFullBarLoop

    ret

DispHL:
    ld   de,-1

    ld   (_curRow),de

    call _dispahl

    dec  hl

    call _vputs

    ret

ContrastDn:
    ld   a,-1

    jr   ContrastMain

ContrastUp:
    ld	 a,1

ContrastMain:
    ld	 hl,CONTRAST

    add	 a,(hl)

    and	 $1F

    ld	 (hl),a

    out	 (2),a

    ld	 a,$FF
    ret

CopyVarToBuffer:
    call UpdateCurProg
    rst  20h
    ld   hl,_OP1+1
    ld   c,(hl)
    ld   b,0
    push bc
    inc  hl
    ld   de,TextBuffer
    ldir
    ld   hl,TextBuffer
    pop  bc
    add  hl,bc
    ld   (TextPtr),hl
    ret

Exit:
    call SaveVars
    res  4,(iy+9)
    call _homeup
    jp   _clrScrn

;-----------------variable renaming routines---------------------

RenameVar:
    call CleanUpBuffer
    call ClearDescriptPlace
    ld   a,0
    ld   (ReturnByte),a
    ld   hl,TextBuffer+8
    ld   (TextEndPtr),hl
    call CopyVarToBuffer
    call RenameGetLoop
	jp   z,ScreenSetup
    call UpdateCurProg
    rst  20h
    call _op1toop5
    ld   hl,TextBuffer-2
    rst  20h
    ld   hl,(TextPtr)
    ld   de,TextBuffer
    sbc  hl,de
    ld   a,l
    ld   (_OP1+1),a
    sub  1
    jp   c,ErrorBadName
    ld   a,(_OP1+2)
    sub  $41
    jp   c,ErrorBadName
    rst  10h
    jp   nc,ErrorBadName
    call _op1toop4
    call _op5toop1
    rst  10h
    ld   de,-5
    add  hl,de
    push hl
    call GetVATsize
    ld   a,(_OP4+1)
    ld   b,a
    ld   a,(_OP1+1)
    cp   b
    jr   z,CopyNewName
    jr   c,MoveVATup
MoveVATdown:
    sub  b
    ld   hl,(VAT_END)
    ld   e,a
    ld   d,0
    add  hl,de									;new end of vat
    ld   (VAT_END),hl
    ld   hl,(_OP2+1)							;next vat entry
    push hl										;that will be the source
    ld   e,a
    ld   d,0
    add  hl,de									;de bytes later, we get the destination
    ex   de,hl
    pop  hl
    ld   bc,(_OP2+3)
    lddr
    jr  CopyNewName

MoveVATup:
    ld   c,a
    ld   a,b
    ld   b,c
    sub  b
    ld   hl,(VAT_END)
    push hl
    ld   e,a
    ld   d,0
    sbc  hl,de    
    ld   (VAT_END),hl
    ex   de,hl
    pop  hl
    inc  hl
    inc  de
    ld   bc,(_OP2+3)
    ldir
      
CopyNewName:
    pop  de
    ld   hl,_OP4+1
    ld   b,(hl)
    inc  b
CopyNewNameLoop:
    ld   a,(hl)
    ld   (de),a
    dec  de
    inc  hl
    djnz CopyNewNameLoop
    jp   DTdetecter
    
GetVATsize:
    push hl
    ld   a,(hl)
    ld   e,a
    ld   d,0
    sbc  hl,de
    ld   (_OP2+1),hl
    ld   de,(VAT_END)
    dec  de
    sbc  hl,de
    ld   (_OP2+3),hl
    pop  hl
    ret

ErrorBadName:
    ld   hl,BadName
    jr   c,ShowError
    ld   hl,VarExists
ShowError:
    ld   de,$3902
    ld   (_penCol),de
    call _vputs
    call $4d43
    jp   DTdetecter

;---------------------------------Folder renaming routines--------------------------

RenameFolder:
    ld   a,(CurFolder)
    sub  5
    jp   nc,VarsGetLoop
    call CleanUpBuffer
    call ClearDescriptPlace
    ld   a,1
    ld   (ReturnByte),a
    ld   hl,TextBuffer+8
    ld   (TextEndPtr),hl
    ld   a,'/'
    ld   (TextBuffer),a
    ld   hl,TextBuffer+1
    ld   (TextPtr),hl
	call RenameGetLoop
    jp   z,ScreenSetup
    call CheckCopy1to5
    ld   a,(CurFolder)
    ld   b,a
    ld   a,(PrevFolder)
    cp   b
    jp   nz,ScreenSetup
    call CopyPrevName
    ld   a,(CurFolder)
    ld   (PrevFolder),a 
    jp   ScreenSetup

RenameGetLoop:
    halt
    call TogglePrompt
    call PutPrompt
    call _getcode
    cp   K_NOKEY
    jr   z,RenameGetLoop
	cp   K_EXIT
	ret  z
	cp   K_ALPHA
	jp   z,ToggleAlpha
	cp   K_DEL
	jp   z,BackUp
	cp   K_ENTER
	jp   z,StringDone
	sub  10
	bit  7,a
	jr   c,RenameGetLoop
	ld   hl,JumpTables
	ld   e,a
	ld   d,0
	add  hl,de
	ld   a,(AlphaByte)
	cp   0
	jr   z,NoAdd
	push hl
	ld   h,a
	ld   l,47
	call MUL_HL
	pop  de
	add  hl,de
NoAdd:
	ld   a,(hl)
	cp   0
	jr   z,RenameGetLoop
	ld   hl,(TextPtr)
	ld   de,(TextEndPtr)
	sbc  hl,de
	jp   nc,RenameGetLoop
	ld   hl,(TextPtr)
	ld   (hl),a
	inc  hl
	ld   (TextPtr),hl
	call PutPrompt
	jr   RenameGetLoop

BackUp:
	ld   hl,(TextPtr)
	ld   de,TextBuffer
	sbc  hl,de
	jp   z,RenameGetLoop
	ld   hl,(TextPtr)
	dec  hl
	ld   (TextPtr),hl
	ld   (hl),0
	call ClearDescriptPlace
	call PutPrompt
	jp   RenameGetLoop

ToggleAlpha:
	ld   a,(AlphaByte)
	cp   2
	call z,ToggleIt
	inc  a
	ld   (AlphaByte),a
	call FixPrompt
	call PutPrompt
	jp   RenameGetLoop
ToggleIt:
	ld   a,-1
	ret

PutPrompt:
	ld   hl,$3902
	ld   (_penCol),hl
	ld   hl,PromptBuffer
	call _vputs
	ld   a,(PromptByte)
	call _vputmap
    ld   hl,$1406
    ld   (_curRow),hl
    ld   a,(CursorBuffer)
    call _putc
	ret

TogglePrompt:
    ld   a,(ToggleByte)
    inc  a
    cp   35
    jr   z,ToggleThePromptByte
    ld   (ToggleByte),a
    ret
ToggleThePromptByte:
    xor  a
    ld   (ToggleByte),a
    ld   a,(PromptByte)
    cp   '|'
    jr   z,PutSpace
    ld   a,'|'
    ld   (PromptByte),a
    ret
PutSpace:
    ld   a,' '
    ld   (PromptByte),a
    ret

FixPrompt:
	ld   a,(AlphaByte)
	cp   0
	jr   nz,NotReg
	ld   hl,$DF
	jr   SavePrompt
NotReg:
	cp   1
	jr   nz,NotRegAlpha
	ld   hl,$E1
	jr   SavePrompt
NotRegAlpha:
	ld   hl,$E2
SavePrompt:
	ld   (CursorBuffer),hl
	ret

CleanUpBuffer:
	ld   hl,TextBuffer
	ld   (TextPtr),hl
	ld   b,9
	ld   hl,TextBuffer
ClearBuffer:
	ld   (hl),0
	inc  hl
	djnz ClearBuffer
    ret

StringDone:
    ld   a,(ReturnByte)
    cp   1
    ret  nz
    ld   a,(CurFolder)
    cp   0
    ld   hl,Folders
    jr   z,CopyBuffer
    ld   h,a
    ld   l,9
    call MUL_HL
    ld   de,Folders
    add  hl,de
CopyBuffer:
    ex   de,hl
	ld   hl,TextBuffer
    push hl
    push de
	ld   de,TextBuffer
	ld   hl,(TextPtr)
	sbc  hl,de
    ld   b,l
    inc  b
    pop  de
    pop  hl
CopyBufferLoop:
    ld   a,(hl)
    ld   (de),a
    inc  hl
    inc  de
    djnz CopyBufferLoop
	ret

;--------------------------Password Protection Routines-------------------------

ShutCalcOff:
    res  3,(iy+8)
    set  4,(iy+8)
    call _off
    ld   a,$FF
    ret

ShutDownWP:
    ld   a,(MainPass)
    cp   0
    jr   z,NoPassSet
    res  3,(iy+8)
    set  4,(iy+8)
    call _off
    ld   hl,PassPrompt
    ld   (PromptPtr),hl
    call GetPassword 
    jp   nz,ShutDownWP
    call ComparePWDS
    jp   z,ScreenSetup
    jr   ShutDownWP

NoPassSet:
    call ClearDescriptPlace
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,NoPassSpecified
    call _vputs
    call $4d43
    jp   ScreenSetup

GetNewPass:
    ld   a,(MainPass)
    cp   0
    jr   z,JustNewPass
GetOldPass:	
    ld   hl,OldPassPrompt
    ld   (PromptPtr),hl
    call GetPassword 
    jp   nz,DTdetecter
    call ComparePWDS
    jr   z,JustNewPass
    call ClearDescriptPlace
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,PasswordIncorrect
    call _vputs
    call $4d43
    jp   ScreenSetup
	
JustNewPass:
    ld   hl,NewPassPrompt
    ld   (PromptPtr),hl
    call GetPassword 
    jp   nz,DTdetecter
    call ClearDescriptPlace
    ld   hl,PassBuffer
    ld   de,MainPass
    ld   bc,15
    ldir
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,PasswordChanged
    call _vputs
    call $4d43
    jp   ScreenSetup

GetPassword:
    call ClearDescriptPlace
    ld   hl,PassBuffer
    ld   (PassPtr),hl
    ld   b,34
    ld   hl,PassBuffer
ClearPassBuffer:
    ld   (hl),0
    inc  hl
    djnz ClearPassBuffer
    call PrintPrompt

GetPassLoop:
    halt
    call PrintPrompt
    call TogglePrompt
    call _getcode
    cp   K_NOKEY
    jr   z,GetPassLoop
    cp   K_DEL
    jp   z,PassBackUp
    cp   K_EXIT
    jp   z,ExitPassLoop
    cp   K_ENTER
    jp   z,EndOfPass
    cp   K_SECOND
    jp   z,EndOfPass
    ld   hl,(PassPtr)
    ld   de,PassBuffer+14
    sbc  hl,de
    jp   nc,GetPassLoop
    ld   hl,(PassPtr)
    ld   (hl),a
    inc  hl
    ld   (PassPtr),hl
    ld   de,PassBuffer
    sbc  hl,de
    ex   de,hl
    ld   hl,DisplayBuffer
    add  hl,de
    ld   a,'*'
    ld   (hl),a
    call PrintPrompt
    jr   GetPassLoop

PrintPrompt:
    ld   hl,$3902
    ld   (_penCol),hl
    ld   hl,(PromptPtr)
    call _vputs
    ld   hl,DisplayBuffer
    call _vputs
    ld   a,(PromptByte)
    call _vputmap
    ret

PassBackUp:
    ld   hl,(PassPtr)
    ld   de,PassBuffer
    sbc  hl,de
    jp   z,GetPassLoop
    ld   hl,(PassPtr)
    dec  hl
    ld   (PassPtr),hl
    ld   (hl),0
    ld   de,PassBuffer
    sbc  hl,de 
    ex   de,hl
    ld   hl,DisplayBuffer
    add  hl,de
    ld   (hl),0
    call ClearDescriptPlace
    call PrintPrompt
    jp   GetPassLoop

EndOfPass:
    cp   a
	ret
ExitPassLoop:
    ld   a,0
    cp   1
	ret

ComparePWDS:
    ld   hl,MainPass
    ld   ix,PassBuffer
    ld   b,15
CompareLoop:
    ld   a,(hl)
    ld   c,(ix)
    cp   c
    ret  nz
    inc  hl
    inc  ix
    djnz CompareLoop
    ret

SaveVars:
    call _op1toop5
    ld   hl,mseVAT
    rst  20h
    rst  10h
    ret  c
    ld   a,b
    ex   de,hl
    call _load_ram_ahl
    call SetPorts4Move
    ld   de,StartSave-$D748+4
    add  hl,de
    ld   bc,EndSave-StartSave
    ex   de,hl
    ld   hl,StartSave
    ldir
    call SetPortsNorm
    call _op5toop1
    ret

ProgramName:
    .db "MSE v5.0  by Chicane",0

mseVAT:
    .db $12,$03,"mse"

MoveWhere:
    .db "Move Where?",0

VarExists:
    .db "Variable Already Exists!",0

BadName:
    .db "Illegal Variable Name!",0

PromptByte:
    .db  '|'

ToggleByte:
    .db  0

TextPtr:
	.dw  TextBuffer

TextEndPtr:
    .dw  TextBuffer+8

PromptBuffer:
	.db  "New Name:"

TextBuffer:
	.db  0,0,0,0,0,0,0,0,0

CursorBuffer:
	.db  $E1,0

AlphaByte:
	.db  1

ReturnByte:
    .db  0

folderDThere:
    .db 0

folderDTname:
    .db $0C,$08,"folderDT"

JumpTables:
	.db  '+','-','*','/','^',0,0
	.db  ' ','3','6','9',')',0,0,0
	.db  '.','2','5','8','(',0,0,0
	.db  '0','1','4','7',0,0,0,0,0,0
	.db  0,0,0,0,0
	.db  0,0,0,0,0,0,0,0,0

	.db  'X','T','O','J','E',0,0
	.db  ' ','W','S','N','I','D',0,0
	.db  'Z','V','R','M','H','C',0,0
	.db  'Y','U','Q','L','G','B',0,0,0,0
	.db  'P','K','F','A',0
	.db  0,0,0,0,0,0,0,0,0

	.db  'x','t','o','j','e',0,0
	.db  ' ','w','s','n','i','d',0,0
	.db  'z','v','r','m','h','c',0,0
	.db  'y','u','q','l','g','b',0,0,0,0
	.db  'p','k','f','a',0
	.db  0,0,0,0,0,0,0,0,0

SizeStr:
    .db "Size:",0

TypeStr:
    .db "Type:",0

Spaces_Str:
    .db "   ",0

NoProgs_Str:
    .db "No Programs",0

FreeStr:
    .db "Free Memory: ",0

BytesStr:
    .db " bytes",0

FileCutStr:
    .db "File placed in paste queue",0

tmpVarPtr:
    .dw 0000

PromptPtr:
	.dw 0000

OldPassPrompt:
	.db "Old Pass:",0

NewPassPrompt:
	.db "New Pass:",0

PassPrompt:
        .db "Pass:",0

PasswordChanged:
	.db "Password Changed!",0

PasswordIncorrect:
	.db "Password Incorrect!",0

NoPassSpecified:
	.db "No Password Specified!",0

PassPtr:
	.dw	0000

PassBuffer:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DisplayBuffer:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

StartSave:
Posr:
    .db 1

VarPage:
    .db 1

CurVar:
    .db 1
    
CurFolder:
    .db  0

PrevFolder:
    .db  0

TotalFolders:
    .db	4

PassState:
	.db 0

MainPass:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

Copy_Queue:
    .db 0,0,0,0,0,0,0,0,0,0

CurFolderStr:
    .db "/root",0,0,0,0

PrevFolderStr:
    .db "/trash",0,0,0

Folders:
    .db "/root",0,0,0,0
    .db "/etc",0,0,0,0,0
    .db "/math",0,0,0,0
    .db "/misc",0,0,0,0
    .db "/trash",0,0,0
EndSave:

.end
