#include "ti86asm.inc"

_exec_asm		equ		$5730	;Execute z80 assembly program in OP1.


.org $0000

	nop
	.db 'M'

	.dw StartComment
	.dw EndComment-StartComment

	.dw StartExec
	.dw EndExec-StartExec

DetectionTables:
	.db 2
	.db $12,'Z',3
	.dw $0028					;This will reverse, so second byte is the mask,
 	.dw $5A28					;$5a is an Z
	.dw $3A28					
	.db $12,'I',3
	.dw $0028
	.dw $4128
	.dw $3A28

StartComment:
    ld      b,a
	inc		hl
	inc     hl
	inc		hl
	ld		a,(hl)
	cp		$d6
	jr		z,ExitWC
    push    hl
    ld      a,b
	cp      'Z'
    jr      nz,Include
    ld      hl,$E700 + (z80SourceTxt - StartComment)
    jr      FinishMove
Include:
    ld      hl,$E700 + (z80IncludeTxt - StartComment)
FinishMove:
    ld      de,_OP2+3
    ld      bc,12
    ldir
    pop     hl
	ld		de,_OP2+15
CopyDesc:
	ld		a,(hl)
	cp		$d6
	jr		z,PutEndingZero
	ld		(de),a
	inc		hl
	inc		de
	jr		CopyDesc
PutEndingZero:
	xor		a
	ld		(de),a
	or		a
	ret
ExitWC:
	scf
	ret

z80SourceTxt:
    .db "ZAC Source: "
z80IncludeTxt:
    .db "ZAC Include:",0

EndComment:

StartExec:
	ld   hl,_OP1
	ld   de,_OP6
	ld   bc,10
	ldir
	set  ex_asm_module,(iy+anumeditflgs)
StartEditor:
	ld	 hl,$E700 + (AsmIDE - StartExec)	;addressing is funky cuz we had to .org 0
	rst  20h
	rst  10h
	jr   c,StartCompiler
Finish:
	ld	 hl,$D748
	push hl
	jp	 _exec_asm

StartCompiler:
	ld   a,(_OP6)
	cp   'I'
	jr   z,EndIt
	ld	 hl,$E000 + (ZAC - StartExec)	;addressing is funky cuz we had to .org 0
	rst  20h
	rst  10h
	jr   nc,Finish
EndIt:
	jp   _asm_exec_ram

AsmIDE:
	.db $12,$08,"Asmide86"
ZAC:
	.db $12,$03,"Zac"
EndExec:

.end
